package com.hai.dao;

import com.hai.entity.HighApprove;
import com.hai.entity.HighApproveExample.Criteria;
import com.hai.entity.HighApproveExample.Criterion;
import com.hai.entity.HighApproveExample;
import java.util.List;
import java.util.Map;
import org.apache.ibatis.jdbc.SQL;

public class HighApproveSqlProvider {

    public String countByExample(HighApproveExample example) {
        SQL sql = new SQL();
        sql.SELECT("count(*)").FROM("high_approve");
        applyWhere(sql, example, false);
        return sql.toString();
    }

    public String deleteByExample(HighApproveExample example) {
        SQL sql = new SQL();
        sql.DELETE_FROM("high_approve");
        applyWhere(sql, example, false);
        return sql.toString();
    }

    public String insertSelective(HighApprove record) {
        SQL sql = new SQL();
        sql.INSERT_INTO("high_approve");
        
        if (record.getObjectType() != null) {
            sql.VALUES("object_type", "#{objectType,jdbcType=INTEGER}");
        }
        
        if (record.getObjectId() != null) {
            sql.VALUES("object_id", "#{objectId,jdbcType=BIGINT}");
        }
        
        if (record.getObjectName() != null) {
            sql.VALUES("object_name", "#{objectName,jdbcType=VARCHAR}");
        }
        
        if (record.getApproveSerialNo() != null) {
            sql.VALUES("approve_serial_no", "#{approveSerialNo,jdbcType=VARCHAR}");
        }
        
        if (record.getRemarks() != null) {
            sql.VALUES("remarks", "#{remarks,jdbcType=VARCHAR}");
        }
        
        if (record.getStatus() != null) {
            sql.VALUES("`status`", "#{status,jdbcType=INTEGER}");
        }
        
        if (record.getCreateTime() != null) {
            sql.VALUES("create_time", "#{createTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getUpdateTime() != null) {
            sql.VALUES("update_time", "#{updateTime,jdbcType=DATE}");
        }
        
        if (record.getSubmitOperatorId() != null) {
            sql.VALUES("submit_operator_id", "#{submitOperatorId,jdbcType=BIGINT}");
        }
        
        if (record.getSubmitOperatorName() != null) {
            sql.VALUES("submit_operator_name", "#{submitOperatorName,jdbcType=VARCHAR}");
        }
        
        if (record.getApproveOperatorId() != null) {
            sql.VALUES("approve_operator_id", "#{approveOperatorId,jdbcType=BIGINT}");
        }
        
        if (record.getApproveOperatorName() != null) {
            sql.VALUES("approve_operator_name", "#{approveOperatorName,jdbcType=VARCHAR}");
        }
        
        if (record.getExt1() != null) {
            sql.VALUES("ext_1", "#{ext1,jdbcType=VARCHAR}");
        }
        
        if (record.getExt2() != null) {
            sql.VALUES("ext_2", "#{ext2,jdbcType=VARCHAR}");
        }
        
        if (record.getExt3() != null) {
            sql.VALUES("ext_3", "#{ext3,jdbcType=VARCHAR}");
        }
        
        if (record.getApproveObject() != null) {
            sql.VALUES("approve_object", "#{approveObject,jdbcType=LONGVARCHAR}");
        }
        
        return sql.toString();
    }

    public String selectByExampleWithBLOBs(HighApproveExample example) {
        SQL sql = new SQL();
        if (example != null && example.isDistinct()) {
            sql.SELECT_DISTINCT("id");
        } else {
            sql.SELECT("id");
        }
        sql.SELECT("object_type");
        sql.SELECT("object_id");
        sql.SELECT("object_name");
        sql.SELECT("approve_serial_no");
        sql.SELECT("remarks");
        sql.SELECT("`status`");
        sql.SELECT("create_time");
        sql.SELECT("update_time");
        sql.SELECT("submit_operator_id");
        sql.SELECT("submit_operator_name");
        sql.SELECT("approve_operator_id");
        sql.SELECT("approve_operator_name");
        sql.SELECT("ext_1");
        sql.SELECT("ext_2");
        sql.SELECT("ext_3");
        sql.SELECT("approve_object");
        sql.FROM("high_approve");
        applyWhere(sql, example, false);
        
        if (example != null && example.getOrderByClause() != null) {
            sql.ORDER_BY(example.getOrderByClause());
        }
        
        return sql.toString();
    }

    public String selectByExample(HighApproveExample example) {
        SQL sql = new SQL();
        if (example != null && example.isDistinct()) {
            sql.SELECT_DISTINCT("id");
        } else {
            sql.SELECT("id");
        }
        sql.SELECT("object_type");
        sql.SELECT("object_id");
        sql.SELECT("object_name");
        sql.SELECT("approve_serial_no");
        sql.SELECT("remarks");
        sql.SELECT("`status`");
        sql.SELECT("create_time");
        sql.SELECT("update_time");
        sql.SELECT("submit_operator_id");
        sql.SELECT("submit_operator_name");
        sql.SELECT("approve_operator_id");
        sql.SELECT("approve_operator_name");
        sql.SELECT("ext_1");
        sql.SELECT("ext_2");
        sql.SELECT("ext_3");
        sql.FROM("high_approve");
        applyWhere(sql, example, false);
        
        if (example != null && example.getOrderByClause() != null) {
            sql.ORDER_BY(example.getOrderByClause());
        }
        
        return sql.toString();
    }

    public String updateByExampleSelective(Map<String, Object> parameter) {
        HighApprove record = (HighApprove) parameter.get("record");
        HighApproveExample example = (HighApproveExample) parameter.get("example");
        
        SQL sql = new SQL();
        sql.UPDATE("high_approve");
        
        if (record.getId() != null) {
            sql.SET("id = #{record.id,jdbcType=BIGINT}");
        }
        
        if (record.getObjectType() != null) {
            sql.SET("object_type = #{record.objectType,jdbcType=INTEGER}");
        }
        
        if (record.getObjectId() != null) {
            sql.SET("object_id = #{record.objectId,jdbcType=BIGINT}");
        }
        
        if (record.getObjectName() != null) {
            sql.SET("object_name = #{record.objectName,jdbcType=VARCHAR}");
        }
        
        if (record.getApproveSerialNo() != null) {
            sql.SET("approve_serial_no = #{record.approveSerialNo,jdbcType=VARCHAR}");
        }
        
        if (record.getRemarks() != null) {
            sql.SET("remarks = #{record.remarks,jdbcType=VARCHAR}");
        }
        
        if (record.getStatus() != null) {
            sql.SET("`status` = #{record.status,jdbcType=INTEGER}");
        }
        
        if (record.getCreateTime() != null) {
            sql.SET("create_time = #{record.createTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getUpdateTime() != null) {
            sql.SET("update_time = #{record.updateTime,jdbcType=DATE}");
        }
        
        if (record.getSubmitOperatorId() != null) {
            sql.SET("submit_operator_id = #{record.submitOperatorId,jdbcType=BIGINT}");
        }
        
        if (record.getSubmitOperatorName() != null) {
            sql.SET("submit_operator_name = #{record.submitOperatorName,jdbcType=VARCHAR}");
        }
        
        if (record.getApproveOperatorId() != null) {
            sql.SET("approve_operator_id = #{record.approveOperatorId,jdbcType=BIGINT}");
        }
        
        if (record.getApproveOperatorName() != null) {
            sql.SET("approve_operator_name = #{record.approveOperatorName,jdbcType=VARCHAR}");
        }
        
        if (record.getExt1() != null) {
            sql.SET("ext_1 = #{record.ext1,jdbcType=VARCHAR}");
        }
        
        if (record.getExt2() != null) {
            sql.SET("ext_2 = #{record.ext2,jdbcType=VARCHAR}");
        }
        
        if (record.getExt3() != null) {
            sql.SET("ext_3 = #{record.ext3,jdbcType=VARCHAR}");
        }
        
        if (record.getApproveObject() != null) {
            sql.SET("approve_object = #{record.approveObject,jdbcType=LONGVARCHAR}");
        }
        
        applyWhere(sql, example, true);
        return sql.toString();
    }

    public String updateByExampleWithBLOBs(Map<String, Object> parameter) {
        SQL sql = new SQL();
        sql.UPDATE("high_approve");
        
        sql.SET("id = #{record.id,jdbcType=BIGINT}");
        sql.SET("object_type = #{record.objectType,jdbcType=INTEGER}");
        sql.SET("object_id = #{record.objectId,jdbcType=BIGINT}");
        sql.SET("object_name = #{record.objectName,jdbcType=VARCHAR}");
        sql.SET("approve_serial_no = #{record.approveSerialNo,jdbcType=VARCHAR}");
        sql.SET("remarks = #{record.remarks,jdbcType=VARCHAR}");
        sql.SET("`status` = #{record.status,jdbcType=INTEGER}");
        sql.SET("create_time = #{record.createTime,jdbcType=TIMESTAMP}");
        sql.SET("update_time = #{record.updateTime,jdbcType=DATE}");
        sql.SET("submit_operator_id = #{record.submitOperatorId,jdbcType=BIGINT}");
        sql.SET("submit_operator_name = #{record.submitOperatorName,jdbcType=VARCHAR}");
        sql.SET("approve_operator_id = #{record.approveOperatorId,jdbcType=BIGINT}");
        sql.SET("approve_operator_name = #{record.approveOperatorName,jdbcType=VARCHAR}");
        sql.SET("ext_1 = #{record.ext1,jdbcType=VARCHAR}");
        sql.SET("ext_2 = #{record.ext2,jdbcType=VARCHAR}");
        sql.SET("ext_3 = #{record.ext3,jdbcType=VARCHAR}");
        sql.SET("approve_object = #{record.approveObject,jdbcType=LONGVARCHAR}");
        
        HighApproveExample example = (HighApproveExample) parameter.get("example");
        applyWhere(sql, example, true);
        return sql.toString();
    }

    public String updateByExample(Map<String, Object> parameter) {
        SQL sql = new SQL();
        sql.UPDATE("high_approve");
        
        sql.SET("id = #{record.id,jdbcType=BIGINT}");
        sql.SET("object_type = #{record.objectType,jdbcType=INTEGER}");
        sql.SET("object_id = #{record.objectId,jdbcType=BIGINT}");
        sql.SET("object_name = #{record.objectName,jdbcType=VARCHAR}");
        sql.SET("approve_serial_no = #{record.approveSerialNo,jdbcType=VARCHAR}");
        sql.SET("remarks = #{record.remarks,jdbcType=VARCHAR}");
        sql.SET("`status` = #{record.status,jdbcType=INTEGER}");
        sql.SET("create_time = #{record.createTime,jdbcType=TIMESTAMP}");
        sql.SET("update_time = #{record.updateTime,jdbcType=DATE}");
        sql.SET("submit_operator_id = #{record.submitOperatorId,jdbcType=BIGINT}");
        sql.SET("submit_operator_name = #{record.submitOperatorName,jdbcType=VARCHAR}");
        sql.SET("approve_operator_id = #{record.approveOperatorId,jdbcType=BIGINT}");
        sql.SET("approve_operator_name = #{record.approveOperatorName,jdbcType=VARCHAR}");
        sql.SET("ext_1 = #{record.ext1,jdbcType=VARCHAR}");
        sql.SET("ext_2 = #{record.ext2,jdbcType=VARCHAR}");
        sql.SET("ext_3 = #{record.ext3,jdbcType=VARCHAR}");
        
        HighApproveExample example = (HighApproveExample) parameter.get("example");
        applyWhere(sql, example, true);
        return sql.toString();
    }

    public String updateByPrimaryKeySelective(HighApprove record) {
        SQL sql = new SQL();
        sql.UPDATE("high_approve");
        
        if (record.getObjectType() != null) {
            sql.SET("object_type = #{objectType,jdbcType=INTEGER}");
        }
        
        if (record.getObjectId() != null) {
            sql.SET("object_id = #{objectId,jdbcType=BIGINT}");
        }
        
        if (record.getObjectName() != null) {
            sql.SET("object_name = #{objectName,jdbcType=VARCHAR}");
        }
        
        if (record.getApproveSerialNo() != null) {
            sql.SET("approve_serial_no = #{approveSerialNo,jdbcType=VARCHAR}");
        }
        
        if (record.getRemarks() != null) {
            sql.SET("remarks = #{remarks,jdbcType=VARCHAR}");
        }
        
        if (record.getStatus() != null) {
            sql.SET("`status` = #{status,jdbcType=INTEGER}");
        }
        
        if (record.getCreateTime() != null) {
            sql.SET("create_time = #{createTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getUpdateTime() != null) {
            sql.SET("update_time = #{updateTime,jdbcType=DATE}");
        }
        
        if (record.getSubmitOperatorId() != null) {
            sql.SET("submit_operator_id = #{submitOperatorId,jdbcType=BIGINT}");
        }
        
        if (record.getSubmitOperatorName() != null) {
            sql.SET("submit_operator_name = #{submitOperatorName,jdbcType=VARCHAR}");
        }
        
        if (record.getApproveOperatorId() != null) {
            sql.SET("approve_operator_id = #{approveOperatorId,jdbcType=BIGINT}");
        }
        
        if (record.getApproveOperatorName() != null) {
            sql.SET("approve_operator_name = #{approveOperatorName,jdbcType=VARCHAR}");
        }
        
        if (record.getExt1() != null) {
            sql.SET("ext_1 = #{ext1,jdbcType=VARCHAR}");
        }
        
        if (record.getExt2() != null) {
            sql.SET("ext_2 = #{ext2,jdbcType=VARCHAR}");
        }
        
        if (record.getExt3() != null) {
            sql.SET("ext_3 = #{ext3,jdbcType=VARCHAR}");
        }
        
        if (record.getApproveObject() != null) {
            sql.SET("approve_object = #{approveObject,jdbcType=LONGVARCHAR}");
        }
        
        sql.WHERE("id = #{id,jdbcType=BIGINT}");
        
        return sql.toString();
    }

    protected void applyWhere(SQL sql, HighApproveExample example, boolean includeExamplePhrase) {
        if (example == null) {
            return;
        }
        
        String parmPhrase1;
        String parmPhrase1_th;
        String parmPhrase2;
        String parmPhrase2_th;
        String parmPhrase3;
        String parmPhrase3_th;
        if (includeExamplePhrase) {
            parmPhrase1 = "%s #{example.oredCriteria[%d].allCriteria[%d].value}";
            parmPhrase1_th = "%s #{example.oredCriteria[%d].allCriteria[%d].value,typeHandler=%s}";
            parmPhrase2 = "%s #{example.oredCriteria[%d].allCriteria[%d].value} and #{example.oredCriteria[%d].criteria[%d].secondValue}";
            parmPhrase2_th = "%s #{example.oredCriteria[%d].allCriteria[%d].value,typeHandler=%s} and #{example.oredCriteria[%d].criteria[%d].secondValue,typeHandler=%s}";
            parmPhrase3 = "#{example.oredCriteria[%d].allCriteria[%d].value[%d]}";
            parmPhrase3_th = "#{example.oredCriteria[%d].allCriteria[%d].value[%d],typeHandler=%s}";
        } else {
            parmPhrase1 = "%s #{oredCriteria[%d].allCriteria[%d].value}";
            parmPhrase1_th = "%s #{oredCriteria[%d].allCriteria[%d].value,typeHandler=%s}";
            parmPhrase2 = "%s #{oredCriteria[%d].allCriteria[%d].value} and #{oredCriteria[%d].criteria[%d].secondValue}";
            parmPhrase2_th = "%s #{oredCriteria[%d].allCriteria[%d].value,typeHandler=%s} and #{oredCriteria[%d].criteria[%d].secondValue,typeHandler=%s}";
            parmPhrase3 = "#{oredCriteria[%d].allCriteria[%d].value[%d]}";
            parmPhrase3_th = "#{oredCriteria[%d].allCriteria[%d].value[%d],typeHandler=%s}";
        }
        
        StringBuilder sb = new StringBuilder();
        List<Criteria> oredCriteria = example.getOredCriteria();
        boolean firstCriteria = true;
        for (int i = 0; i < oredCriteria.size(); i++) {
            Criteria criteria = oredCriteria.get(i);
            if (criteria.isValid()) {
                if (firstCriteria) {
                    firstCriteria = false;
                } else {
                    sb.append(" or ");
                }
                
                sb.append('(');
                List<Criterion> criterions = criteria.getAllCriteria();
                boolean firstCriterion = true;
                for (int j = 0; j < criterions.size(); j++) {
                    Criterion criterion = criterions.get(j);
                    if (firstCriterion) {
                        firstCriterion = false;
                    } else {
                        sb.append(" and ");
                    }
                    
                    if (criterion.isNoValue()) {
                        sb.append(criterion.getCondition());
                    } else if (criterion.isSingleValue()) {
                        if (criterion.getTypeHandler() == null) {
                            sb.append(String.format(parmPhrase1, criterion.getCondition(), i, j));
                        } else {
                            sb.append(String.format(parmPhrase1_th, criterion.getCondition(), i, j,criterion.getTypeHandler()));
                        }
                    } else if (criterion.isBetweenValue()) {
                        if (criterion.getTypeHandler() == null) {
                            sb.append(String.format(parmPhrase2, criterion.getCondition(), i, j, i, j));
                        } else {
                            sb.append(String.format(parmPhrase2_th, criterion.getCondition(), i, j, criterion.getTypeHandler(), i, j, criterion.getTypeHandler()));
                        }
                    } else if (criterion.isListValue()) {
                        sb.append(criterion.getCondition());
                        sb.append(" (");
                        List<?> listItems = (List<?>) criterion.getValue();
                        boolean comma = false;
                        for (int k = 0; k < listItems.size(); k++) {
                            if (comma) {
                                sb.append(", ");
                            } else {
                                comma = true;
                            }
                            if (criterion.getTypeHandler() == null) {
                                sb.append(String.format(parmPhrase3, i, j, k));
                            } else {
                                sb.append(String.format(parmPhrase3_th, i, j, k, criterion.getTypeHandler()));
                            }
                        }
                        sb.append(')');
                    }
                }
                sb.append(')');
            }
        }
        
        if (sb.length() > 0) {
            sql.WHERE(sb.toString());
        }
    }
}